FBUtilities (apache-cassandra API)
Date: 2018-02-14

org.apache.cassandra.utils

## Class FBUtilities

- java.lang.Object
- - org.apache.cassandra.utils.FBUtilities

-     public class FBUtilities
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static boolean` | `isLinux`
    `static boolean` | `isWindows`
    `static int` | `MAX_UNSIGNED_SHORT`
    `static java.math.BigInteger` | `TWO`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FBUtilities()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static long` | `abs(long index)`
    `static long` | `align(long val, int boundary)`
    `static java.io.File` | `cassandraTriggerDir()`
    `static <T> java.lang.Class<T>` | `classForName(java.lang.String classname, java.lang.String readable)`
    `static <T> CloseableIterator<T>` | `closeableIterator(java.util.Iterator<T> iterator)`
    `static void` | `closeAll(java.util.List<? extends java.lang.AutoCloseable> l)`
    `static int` | `compareUnsigned(byte[] bytes1, byte[] bytes2)`
    `static int` | `compareUnsigned(byte[] bytes1, byte[] bytes2, int offset1, int offset2, int len1, int len2)`
    `static <T> T` | `construct(java.lang.String classname, java.lang.String readable)` Constructs an instance of the given class, which must have a no-arg or default constructor.
    `static long` | `copy(java.io.InputStream from, java.io.OutputStream to, long limit)`
    `static <T> java.util.NavigableSet<T>` | `emptySortedSet(java.util.Comparator<? super T> comparator)`
    `static void` | `exec(java.lang.ProcessBuilder pb)` Starts and waits for the given @param pb to finish.
    `static java.util.List<java.lang.String>` | `fromJsonList(java.lang.String json)`
    `static java.util.Map<java.lang.String,java.lang.String>` | `fromJsonMap(java.lang.String json)`
    `static java.util.Collection<java.net.InetAddress>` | `getAllLocalAddresses()`
    `static int` | `getAvailableProcessors()`
    `static java.net.InetAddress` | `getBroadcastAddress()`
    `static java.net.InetAddress` | `getBroadcastRpcAddress()`
    `static java.net.InetAddress` | `getLocalAddress()` Please use getBroadcastAddress instead.
    `static java.lang.String` | `getNetworkInterface(java.net.InetAddress localAddress)`
    `static java.lang.reflect.Field` | `getProtectedField(java.lang.Class klass, java.lang.String fieldName)` Used to get access to protected/private field of the specified class
    `static java.lang.String` | `getReleaseVersionString()`
    `static java.io.File` | `getToolsOutputDirectory()`
    `static <T> T` | `instanceOrConstruct(java.lang.String classname, java.lang.String readable)` Constructs an instance of the given class, which must have a no-arg or default constructor.
    `static java.lang.String` | `json(java.lang.Object object)`
    `static Pair<java.math.BigInteger,java.lang.Boolean>` | `midpoint(java.math.BigInteger left, java.math.BigInteger right, int sigbits)` Given two bit arrays represented as BigIntegers, containing the given number of significant bits, calculate a midpoint.
    `static IAuthenticator` | `newAuthenticator(java.lang.String className)`
    `static IAuthorizer` | `newAuthorizer(java.lang.String className)`
    `static java.security.MessageDigest` | `newMessageDigest(java.lang.String algorithm)`
    `static IPartitioner` | `newPartitioner(Descriptor desc)` Create a new instance of a partitioner defined in an SSTable Descriptor
    `static IPartitioner` | `newPartitioner(java.lang.String partitionerClassName)`
    `static IRoleManager` | `newRoleManager(java.lang.String className)`
    `static int` | `nowInSeconds()`
    `static java.lang.String` | `prettyPrintMemory(long size)`
    `static java.lang.String` | `prettyPrintMemory(long size, boolean includeSpace)`
    `static java.lang.String` | `prettyPrintMemoryPerSecond(long rate)`
    `static java.lang.String` | `prettyPrintMemoryPerSecond(long bytes, long timeInNano)`
    `protected static void` | `reset()`
    `static java.lang.String` | `resourceToFile(java.lang.String filename)`
    `static <T> byte[]` | `serialize(T object, IVersionedSerializer<T> serializer, int version)`
    `static <T> java.util.NavigableSet<T>` | `singleton(T column, java.util.Comparator<? super T> comparator)`
    `static void` | `sleepQuietly(long millis)`
    `static void` | `sortSampledKeys(java.util.List<DecoratedKey> keys, Range<Token> range)`
    `static java.security.MessageDigest` | `threadLocalMD5Digest()`
    `static long` | `timestampMicros()`
    `static java.lang.String` | `toString(java.util.Map<?,?> map)` Make straing out of the given `Map`.
    `static byte[]` | `toWriteUTFBytes(java.lang.String s)`
    `static void` | `updateChecksum(java.util.zip.CRC32 checksum, java.nio.ByteBuffer buffer)` Updates checksum with the provided ByteBuffer.
    `static void` | `updateChecksum(java.util.zip.CRC32 checksum, java.nio.ByteBuffer buffer, int offset, int length)` Updates checksum with the provided ByteBuffer at the given offset + length.
    `static void` | `updateChecksumInt(java.util.zip.Checksum checksum, int v)`
    `static void` | `updateWithBoolean(java.security.MessageDigest digest, boolean val)`
    `static void` | `updateWithByte(java.security.MessageDigest digest, int val)`
    `static void` | `updateWithInt(java.security.MessageDigest digest, int val)`
    `static void` | `updateWithLong(java.security.MessageDigest digest, long val)`
    `static void` | `updateWithShort(java.security.MessageDigest digest, int val)`
    `static <T> T` | `waitOnFuture(java.util.concurrent.Future<T> future)`
    `static <T> java.util.List<T>` | `waitOnFutures(java.lang.Iterable<? extends java.util.concurrent.Future<? extends T>> futures)`
    `static void` | `waitOnFutures(java.util.List<AsyncOneResponse> results, long ms)`
    `static byte[]` | `xor(byte[] left, byte[] right)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### TWO

          public static final java.math.BigInteger TWO

    - #### isWindows

          public static final boolean isWindows

    - #### isLinux

          public static final boolean isLinux

    - #### MAX_UNSIGNED_SHORT

          public static final int MAX_UNSIGNED_SHORT

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### FBUtilities

          public FBUtilities()

  - ### Method Detail

    - #### getAvailableProcessors

          public static int getAvailableProcessors()

    - #### threadLocalMD5Digest

          public static java.security.MessageDigest threadLocalMD5Digest()

    - #### newMessageDigest

          public static java.security.MessageDigest newMessageDigest(java.lang.String algorithm)

    - #### getLocalAddress

          public static java.net.InetAddress getLocalAddress()

      Please use getBroadcastAddress instead. You need this only when you have to listen/connect.

    - #### getBroadcastAddress

          public static java.net.InetAddress getBroadcastAddress()

    - #### getBroadcastRpcAddress

          public static java.net.InetAddress getBroadcastRpcAddress()

    - #### getAllLocalAddresses

          public static java.util.Collection<java.net.InetAddress> getAllLocalAddresses()

    - #### getNetworkInterface

          public static java.lang.String getNetworkInterface(java.net.InetAddress localAddress)

    - #### midpoint

          public static Pair<java.math.BigInteger,java.lang.Boolean> midpoint(java.math.BigInteger left,
                                                                              java.math.BigInteger right,
                                                                              int sigbits)

      Given two bit arrays represented as BigIntegers, containing the given number of significant bits, calculate a midpoint.
      Parameters:
        `left` - The left point.
        `right` - The right point.
        `sigbits` - The number of bits in the points that are significant.
      Returns:
        A midpoint that will compare bitwise halfway between the params, and a boolean representing whether a non-zero lsbit remainder was generated.

    - #### compareUnsigned

          public static int compareUnsigned(byte[] bytes1,
                                            byte[] bytes2,
                                            int offset1,
                                            int offset2,
                                            int len1,
                                            int len2)

    - #### compareUnsigned

          public static int compareUnsigned(byte[] bytes1,
                                            byte[] bytes2)

    - #### xor

          public static byte[] xor(byte[] left,
                                   byte[] right)

      Returns:
        The bitwise XOR of the inputs. The output will be the same length as the longer input, but if either input is null, the output will be null.

    - #### sortSampledKeys

          public static void sortSampledKeys(java.util.List<DecoratedKey> keys,
                                             Range<Token> range)

    - #### resourceToFile

          public static java.lang.String resourceToFile(java.lang.String filename)
                                                 throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### cassandraTriggerDir

          public static java.io.File cassandraTriggerDir()

    - #### getReleaseVersionString

          public static java.lang.String getReleaseVersionString()

    - #### timestampMicros

          public static long timestampMicros()

    - #### nowInSeconds

          public static int nowInSeconds()

    - #### waitOnFutures

          public static <T> java.util.List<T> waitOnFutures(java.lang.Iterable<? extends java.util.concurrent.Future<? extends T>> futures)

    - #### waitOnFuture

          public static <T> T waitOnFuture(java.util.concurrent.Future<T> future)

    - #### waitOnFutures

          public static void waitOnFutures(java.util.List<AsyncOneResponse> results,
                                           long ms)
                                    throws java.util.concurrent.TimeoutException

      Throws:
        `java.util.concurrent.TimeoutException`

    - #### newPartitioner

          public static IPartitioner newPartitioner(Descriptor desc)
                                             throws java.io.IOException

      Create a new instance of a partitioner defined in an SSTable Descriptor
      Parameters:
        `desc` - Descriptor of an sstable
      Returns:
        a new IPartitioner instance
      Throws:
        `java.io.IOException`

    - #### newPartitioner

          public static IPartitioner newPartitioner(java.lang.String partitionerClassName)
                                             throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### newAuthorizer

          public static IAuthorizer newAuthorizer(java.lang.String className)
                                           throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### newAuthenticator

          public static IAuthenticator newAuthenticator(java.lang.String className)
                                                 throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### newRoleManager

          public static IRoleManager newRoleManager(java.lang.String className)
                                             throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### classForName

          public static <T> java.lang.Class<T> classForName(java.lang.String classname,
                                                            java.lang.String readable)
                                                     throws ConfigurationException

      Parameters:
        `classname` - Fully qualified classname.
        `readable` - Descriptive noun for the role the class plays.
      Returns:
        The Class for the given name.
      Throws:
        `ConfigurationException` - If the class cannot be found.

    - #### instanceOrConstruct

          public static <T> T instanceOrConstruct(java.lang.String classname,
                                                  java.lang.String readable)
                                           throws ConfigurationException

      Constructs an instance of the given class, which must have a no-arg or default constructor.
      Parameters:
        `classname` - Fully qualified classname.
        `readable` - Descriptive noun for the role the class plays.
      Throws:
        `ConfigurationException` - If the class cannot be found.

    - #### construct

          public static <T> T construct(java.lang.String classname,
                                        java.lang.String readable)
                                 throws ConfigurationException

      Constructs an instance of the given class, which must have a no-arg or default constructor.
      Parameters:
        `classname` - Fully qualified classname.
        `readable` - Descriptive noun for the role the class plays.
      Throws:
        `ConfigurationException` - If the class cannot be found.

    - #### singleton

          public static <T> java.util.NavigableSet<T> singleton(T column,
                                                                java.util.Comparator<? super T> comparator)

    - #### emptySortedSet

          public static <T> java.util.NavigableSet<T> emptySortedSet(java.util.Comparator<? super T> comparator)

    - #### toString

          @Nonnull
          public static java.lang.String toString(@Nullable
                                                           java.util.Map<?,?> map)

      Make straing out of the given `Map`.
      Parameters:
        `map` - Map to make string.
      Returns:
        String representation of all entries in the map, where key and value pair is concatenated with ':'.

    - #### getProtectedField

          public static java.lang.reflect.Field getProtectedField(java.lang.Class klass,
                                                                  java.lang.String fieldName)

      Used to get access to protected/private field of the specified class
      Parameters:
        `klass` - - name of the class
        `fieldName` - - name of the field
      Returns:
        Field or null on error

    - #### closeableIterator

          public static <T> CloseableIterator<T> closeableIterator(java.util.Iterator<T> iterator)

    - #### fromJsonMap

          public static java.util.Map<java.lang.String,java.lang.String> fromJsonMap(java.lang.String json)

    - #### fromJsonList

          public static java.util.List<java.lang.String> fromJsonList(java.lang.String json)

    - #### json

          public static java.lang.String json(java.lang.Object object)

    - #### prettyPrintMemory

          public static java.lang.String prettyPrintMemory(long size)

    - #### prettyPrintMemory

          public static java.lang.String prettyPrintMemory(long size,
                                                           boolean includeSpace)

    - #### prettyPrintMemoryPerSecond

          public static java.lang.String prettyPrintMemoryPerSecond(long rate)

    - #### prettyPrintMemoryPerSecond

          public static java.lang.String prettyPrintMemoryPerSecond(long bytes,
                                                                    long timeInNano)

    - #### exec

          public static void exec(java.lang.ProcessBuilder pb)
                           throws java.io.IOException

      Starts and waits for the given @param pb to finish.
      Throws:
        `java.io.IOException` - on non-zero exit code

    - #### updateChecksumInt

          public static void updateChecksumInt(java.util.zip.Checksum checksum,
                                               int v)

    - #### updateChecksum

          public static void updateChecksum(java.util.zip.CRC32 checksum,
                                            java.nio.ByteBuffer buffer,
                                            int offset,
                                            int length)

      Updates checksum with the provided ByteBuffer at the given offset + length. Resets position and limit back to their original values on return. This method is *NOT* thread-safe.

    - #### updateChecksum

          public static void updateChecksum(java.util.zip.CRC32 checksum,
                                            java.nio.ByteBuffer buffer)

      Updates checksum with the provided ByteBuffer. Resets position back to its original values on return. This method is *NOT* thread-safe.

    - #### abs

          public static long abs(long index)

    - #### serialize

          public static <T> byte[] serialize(T object,
                                             IVersionedSerializer<T> serializer,
                                             int version)

    - #### copy

          public static long copy(java.io.InputStream from,
                                  java.io.OutputStream to,
                                  long limit)
                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getToolsOutputDirectory

          public static java.io.File getToolsOutputDirectory()

    - #### updateWithShort

          public static void updateWithShort(java.security.MessageDigest digest,
                                             int val)

    - #### updateWithByte

          public static void updateWithByte(java.security.MessageDigest digest,
                                            int val)

    - #### updateWithInt

          public static void updateWithInt(java.security.MessageDigest digest,
                                           int val)

    - #### updateWithLong

          public static void updateWithLong(java.security.MessageDigest digest,
                                            long val)

    - #### updateWithBoolean

          public static void updateWithBoolean(java.security.MessageDigest digest,
                                               boolean val)

    - #### closeAll

          public static void closeAll(java.util.List<? extends java.lang.AutoCloseable> l)
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### toWriteUTFBytes

          public static byte[] toWriteUTFBytes(java.lang.String s)

    - #### sleepQuietly

          public static void sleepQuietly(long millis)

    - #### align

          public static long align(long val,
                                   int boundary)

    - #### reset

          protected static void reset()

Copyright © 2018 The Apache Software Foundation